std::istream_iterator< _Tp, _CharT, _Traits, _Dist > Class Template Reference
Iterators

`#include <stream_iterator.h>`

Inheritance diagram for std::istream_iterator< _Tp, _CharT, _Traits, _Dist >:
[legend]

## Public Types

typedef _CharT | char_type
typedef _Distance | difference_type
typedef basic_istream< _CharT, _Traits > | istream_type
typedef _Category | iterator_category
typedef _Pointer | pointer
typedef _Reference | reference
typedef _Traits | traits_type
typedef _Tp | value_type

## Public Member Functions

constexpr | istream_iterator ()
| istream_iterator (const istream_iterator &__obj)
| istream_iterator (istream_type &__s)
bool | _M_equal (const istream_iterator &__x) const
const _Tp & | operator* () const
istream_iterator & | operator++ ()
istream_iterator | operator++ (int)
const _Tp * | operator-> () const
istream_iterator & | operator= (const istream_iterator &)=default

## Detailed Description

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>
class std::istream_iterator< _Tp, _CharT, _Traits, _Dist >

Provides input iterator semantics for streams.

Definition at line 49 of file stream_iterator.h.

## Member Typedef Documentation

## char_type

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

typedef _CharT std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::char_type

Definition at line 53 of file stream_iterator.h.

## difference_type

template<typename _Category , typename _Tp , typename _Distance = ptrdiff_t, typename _Pointer = _Tp*, typename _Reference = _Tp&>

typedef _Distance std::iterator< _Category, _Tp, _Distance, _Pointer, _Reference >::difference_type

inherited

Distance between iterators is represented as this type.

Definition at line 125 of file stl_iterator_base_types.h.

## istream_type

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

typedef basic_istream<_CharT, _Traits> std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::istream_type

Definition at line 55 of file stream_iterator.h.

## iterator_category

template<typename _Category , typename _Tp , typename _Distance = ptrdiff_t, typename _Pointer = _Tp*, typename _Reference = _Tp&>

typedef _Category std::iterator< _Category, _Tp, _Distance, _Pointer, _Reference >::iterator_category

inherited

One of the tag types.

Definition at line 121 of file stl_iterator_base_types.h.

## pointer

template<typename _Category , typename _Tp , typename _Distance = ptrdiff_t, typename _Pointer = _Tp*, typename _Reference = _Tp&>

typedef _Pointer std::iterator< _Category, _Tp, _Distance, _Pointer, _Reference >::pointer

inherited

This type represents a pointer-to-value_type.

Definition at line 127 of file stl_iterator_base_types.h.

## reference

template<typename _Category , typename _Tp , typename _Distance = ptrdiff_t, typename _Pointer = _Tp*, typename _Reference = _Tp&>

typedef _Reference std::iterator< _Category, _Tp, _Distance, _Pointer, _Reference >::reference

inherited

This type represents a reference-to-value_type.

Definition at line 129 of file stl_iterator_base_types.h.

## traits_type

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

typedef _Traits std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::traits_type

Definition at line 54 of file stream_iterator.h.

## value_type

template<typename _Category , typename _Tp , typename _Distance = ptrdiff_t, typename _Pointer = _Tp*, typename _Reference = _Tp&>

typedef _Tp std::iterator< _Category, _Tp, _Distance, _Pointer, _Reference >::value_type

inherited

The type "pointed to" by the iterator.

Definition at line 123 of file stl_iterator_base_types.h.

## Constructor & Destructor Documentation

## istream_iterator() [1/3]

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

constexpr std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::istream_iterator | ( |  | ) |

inline constexpr

Construct end of input stream iterator.

Definition at line 64 of file stream_iterator.h.

## istream_iterator() [2/3]

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::istream_iterator | ( | istream_type & | __s | ) |

inline

Construct start of input stream iterator.

Definition at line 68 of file stream_iterator.h.

## istream_iterator() [3/3]

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::istream_iterator | ( | const istream_iterator< _Tp, _CharT, _Traits, _Dist > & | __obj | ) |

inline

Definition at line 72 of file stream_iterator.h.

## Member Function Documentation

## _M_equal()

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

bool std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::_M_equal | ( | const istream_iterator< _Tp, _CharT, _Traits, _Dist > & | __x | ) | const

inline

Definition at line 115 of file stream_iterator.h.

## operator*()

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

const _Tp & std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::operator* | ( |  | ) | const

inline

Definition at line 82 of file stream_iterator.h.

## operator++() [1/2]

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

istream_iterator & std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::operator++ | ( |  | ) |

inline

Definition at line 94 of file stream_iterator.h.

## operator++() [2/2]

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

istream_iterator std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::operator++ | ( | int |  | ) |

inline

Definition at line 104 of file stream_iterator.h.

## operator->()

template<typename _Tp , typename _CharT = char, typename _Traits = char_traits<_CharT>, typename _Dist = ptrdiff_t>

const _Tp * std::istream_iterator< _Tp, _CharT, _Traits, _Dist >::operator-> | ( |  | ) | const

inline

Definition at line 91 of file stream_iterator.h.

The documentation for this class was generated from the following file:

- stream_iterator.h